

#    experiment run control for FEBEX - taken from sys.tcl

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0

global env
global Options

variable SpecBase [file join $env(MIDASBASE) SpecData]
variable SpecPath

       set z [catch {source [file join $env(MIDASBASE) TclHttpd tcl Common febex.tcl]} m]
       if {$z != 0} {puts "loading febex.tcl  > $m"}
       set z [catch {source [file join $env(MIDASBASE) TclHttpd tcl Common options.tcl]} m]
       if {$z != 0} {puts "loading options.tcl  > $m"}


   if {![info exists Options(Histogram.FEBEX)]} {set Options(Histogram.FEBEX) 1}
   if {![info exists Options(FEBEX.NumADCs)]} {set Options(FEBEX.NumADCs) 16}
   
   for {set i 0} {$i < 4} {incr i} {
      if {![info exists Options(FEBEX.Link[set i]NumBoards)]} {set Options(FEBEX.Link[set i]NumBoards) 0}
   }
   
   for {set i 0} {$i < 4} {incr i} {
       CreateNetVar NetVar.DACQ.Link[set i]NumBoards "-n DACQ.Link[set i]NumBoards -t int -p rw -f x -a 0 -l 1"
   }

      if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 2000}
      if {![info exists Options(Stat.shift)]} {set Options(Stat.shift) 6}
      if {![info exists Options(Stat.offset)]} {set Options(Stat.offset) 0}
      
   if {![info exists Options(FEBEX.Eenable)]} {set Options(FEBEX.Eenable) 1}
   if {![info exists Options(FEBEX.Fenable)]} {set Options(FEBEX.Fenable) 1}
   if {![info exists Options(FEBEX.Tenable)]} {set Options(FEBEX.Tenable) 0}
   if {![info exists Options(FEBEX.Wenable)]} {set Options(FEBEX.Wenable) 0}

   if {![info exists Options(FEBEX.Echannels)]} {set Options(FEBEX.Echannels) 8192}
   if {![info exists Options(FEBEX.Fchannels)]} {set Options(FEBEX.Fchannels) 8192}
   if {![info exists Options(FEBEX.Tchannels)]} {set Options(FEBEX.Tchannels) 65535}
   if {![info exists Options(FEBEX.Wchannels)]} {set Options(FEBEX.Wchannels) 1000}
   if {![info exists Options(FEBEX.offset)]} {set Options(FEBEX.offset) 0}
   if {![info exists Options(FEBEX.shift)]} {set Options(FEBEX.shift) 0}
   if {![info exists Options(FEBEX.Tshift)]} {set Options(FEBEX.Tshift) 8}
   if {![info exists Options(FEBEX_GroupBase)]} {set Options(FEBEX_GroupBase) 1}

    if {![info exists Options(FirmWare.Settings)]} {set Options(FirmWare.Settings) "undefined"}
    if {![info exists Options(DataAcqPgm)]} {set Options(DataAcqPgm) FEBEXExecV1}
    
    if {![info exists Options(FEBEX.Link0NumBoards)]} {set Options(FEBEX.Link0NumBoards) 0}
    if {![info exists Options(FEBEX.Link1NumBoards)]} {set Options(FEBEX.Link1NumBoards) 0}
    if {![info exists Options(FEBEX.Link2NumBoards)]} {set Options(FEBEX.Link2NumBoards) 0}
    if {![info exists Options(FEBEX.Link3NumBoards)]} {set Options(FEBEX.Link3NumBoards) 0}

    SaveOptions

   
variable FEBEXregisterlist

set FEBEXregisterlist {}

lappend FEBEXregisterlist [list NetVar.FEBEX_PexorEnable               "-n FEBEX_PexorEnable -t int"]
lappend FEBEXregisterlist [list NetVar.FEBEX_Data_In_Enable            "-n FEBEX_Data_In_Enable -t int"]
lappend FEBEXregisterlist [list NetVar.FEBEX_Data_Out_Enable           "-n FEBEX_Data_Out_Enable -t int"]

lappend FEBEXregisterlist [list NetVar.FEBEX_DataFormat                "-n FEBEX_DataFormat -t int"]
lappend FEBEXregisterlist [list NetVar.FEBEX_Do_DataRead               "-n FEBEX_Do_DataRead -t int"]
lappend FEBEXregisterlist [list NetVar.FEBEX_Do_DataWrite              "-n FEBEX_Do_DataWrite -t int"]

lappend FEBEXregisterlist [list NetVar.FEBEX_DataBase                  "-n FEBEX_DataBase -t string"]
lappend FEBEXregisterlist [list NetVar.FEBEX_DataInFile                "-n FEBEX_DataInFile -t string"]
lappend FEBEXregisterlist [list NetVar.FEBEX_DataOutFile               "-n FEBEX_DataOutFile -t string"]

lappend FEBEXregisterlist [list NetVar.DACQ.Link0NumBoards             "-n FEBEX.Link0NumBoards -t int"]
lappend FEBEXregisterlist [list NetVar.DACQ.Link1NumBoards             "-n FEBEX.Link1NumBoards -t int"]
lappend FEBEXregisterlist [list NetVar.DACQ.Link2NumBoards             "-n FEBEX.Link2NumBoards -t int"]
lappend FEBEXregisterlist [list NetVar.DACQ.Link3NumBoards             "-n FEBEX.Link3NumBoards -t int"]


proc make-FEBEXUIregisters {} {
   variable FEBEXregisterlist

    set rc [catch {ReadNetVar NetVar.FEBEX_PexorEnable} m]
    if {$rc == 0} return
    if {$rc == 1 || $m == 0x10004} {
        foreach item $FEBEXregisterlist {
            set rc [catch {CreateNetVar [first $item] [second $item]} m]
            if {$rc != 0} {puts "CreateNetVar returned $rc $m"}
#            if {$rc == 0} {InsertLog "make-FEBEXUIregisters created [first $item] [second $item]"}
        }
        puts "Created FEBEX UI registers"
    } else {
        puts "make-FEBEXUIregisters returns rc=$rc and $m"
    }
}

   
   proc load_Options {} {LoadOptions}
   proc update_Options {} {SaveOptions}
  
proc Dump_Raw_Data {} {

   set info "FEBEX data Version 1.2\n"
   set c 0
   for {set offset 0} {$offset <= 50} {incr offset 50} {

     DataAcqCommand 19 "Getting Raw Data" "4 $offset" 2
     set data [ReadNetVar NetVar.EXEC.Response]
     
     puts "[first $data] [second $data] [third $data] [fourth $data]"

     foreach word $data {
         set word $word
         if {$word == 0x55555555} then {
             append info "\n$word - end of dump\n"
             set c 0
             break
         }
         if {$word == 0x5a5a5a5a} then {
             append info "\n$word - end of event\n"
             set c 0
             continue
         }
         if {$word == 0xa5a5a5a5} then {
             append info "\n$word - start of data\n"
             set c 0
             continue
         }
         append info "$word "
         incr c

         if {$c == 10} { set c 0 ; append info "\n"}
     }
   }

   return "$info"
}

proc doReset {} {

puts "executing doReset for FEBEX"

     Set_Options; make-UIregisters

     Reset_Electronics
	InsertLog "Reset in sys.tcl"

     DataAcqCommand 9 "Reset"

     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 1 "disconnect xfer stream #1" 0 2
     }
     
}
 
   proc doSetUp {} {
      global Options
      global env
      upvar #0 SpectraHandle f
      
puts "executing doSetup for FEBEX"

     Set_Options; make-UIregisters

     DataAcqCommand 1 "Halt"

     unmap_spectra

     delete_spectra
     
     set SpectraDefs [file join $env(MIDASTempDir) SpectraDefs.dat]

     set z [catch {open $SpectraDefs w} f]
     if {$z != 0} then {puts "Cannot open file $SpectraDefs\n$f"}    

      CreateSpectrum1D Stat $Options(Stat.channels)
      set z [catch {SpectrumPutTitle Stat FEBEX_Stat} m]
      map_spectrum "Stat 0 0 0 $Options(Stat.shift)" 

      CreateSpectrum1D Rate $Options(Stat.channels)
      set z [catch {SpectrumPutTitle Rate FEBEX_Rate} m]

     create_FEBEX_spectra
     
     close $f
    
     map_spectra
     
    Setup_Electronics

    if {[ReadNetVar NetVar.DACQ.Crestoreenable] == 1}  {
         ParameterRestore $Options(FirmWare.Settings)
    }

    DataAcqCommand 3 "Setup"

    WriteNetVar NetVar.DACQ.PollTicks 100
    WriteNetVar NetVar.DACQ.Crdoutenable 1   ;# enable data readout

    puts "completed doSetUp"

 }
 
proc doStop {} {

puts "executing doHalt for FEBEX"

     Set_Options; make-UIregisters

     Halt_Electronics
	InsertLog "Halt in sys.tcl"

     DataAcqCommand 1 "Halt"
     
     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 1 "disconnect xfer stream #0" 0 2
     }

     puts "completed doHalt"
}
  
proc doGo {} {

puts "executing doGo for FEBEX"

     Set_Options; make-UIregisters
     
     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 3 "connect xfer stream #0" 0 2
     }

     Go_Electronics 
       InsertLog "Go in sys.tcl"

     DataAcqCommand 2 "Go"
     
     puts "completed doGo"
}
  
 
 proc Reset_Electronics {} {
       global ModuleMenu LinkMenu BoardMenu
       global Options
 
    puts "Reset_Electronics"
        
        WriteNetVar NetVar.DACQ.Link0NumBoards $Options(FEBEX.Link0NumBoards)
        WriteNetVar NetVar.DACQ.Link1NumBoards $Options(FEBEX.Link1NumBoards)
        WriteNetVar NetVar.DACQ.Link2NumBoards $Options(FEBEX.Link2NumBoards)
        WriteNetVar NetVar.DACQ.Link3NumBoards $Options(FEBEX.Link3NumBoards)
        
    puts "$ModuleMenu"
    puts "$LinkMenu"
    puts "$BoardMenu"
    
    foreach module $ModuleMenu {     puts "module = $module"
           SelectFEBEXModule $module
           
#  sets the device number /dev/pexor/n
           set z [catch {SetupFEBEXRegister $module} m] 
           if {$z != 0} {puts "SetupFEBEXRegister for module $module => $m"}
           
      foreach link $LinkMenu {      puts "link = $link"
          if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
          
           SelectFEBEXLink $link
           
#   initialise the link for n boards
           set z [catch {InitFEBEXRegister $link $Options(FEBEX.Link[set link]NumBoards)}]
           if {$z != 0} {puts "InitFEBEXRegister for link $link boards $Options(FEBEX.Link[set link]NumBoards) => $m"}
           if {$z == 0} {puts "InitFEBEXRegister for link $link boards $Options(FEBEX.Link[set link]NumBoards)"}
           
           for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {  puts "board = $board"
           
           SelectFEBEXBoard $board           
           
#    send reset to time stamp counter and reset LVDS out  -   command not in firmware?

#           set z [catch {WriteFEBEXRegister $link $board $TimeReset 1} m]
#           if {$z != 0} {puts "WriteFEBEXRegister for TimeReset => $m"}
           
#    disable trigger acceptance 
    
           set z [catch {WriteFEBEXRegister $link $board Ctrl 0} m] 
           if {$z != 0} {puts "WriteFEBEXRegister for Ctrl => $m"} 
           
#    reset

           set z [catch {WriteFEBEXRegister $link $board Reset 1} m]
           if {$z != 0} {puts "WriteFEBEXRegister for Reset => $m"}
           
#    disable trigger acceptance   (repeat taken from HS sequence)
    
           set z [catch {WriteFEBEXRegister $link $board Ctrl 0} m]
           if {$z != 0} {puts "WriteFEBEXRegister for Ctrl => $m"} 
        }
      }
    }
  }

  proc Setup_Electronics {} {
      global Options
      global ModuleMenu LinkMenu BoardMenu
      
   global DATA_REDUCTION   DISABLE_CHANNEL  FEB_TRACE_LEN   FEB_TRIG_DELAY
   global FEB4_CODING  FEB4_SPI_READ
  
   puts "Setup_Electronics"
   
    foreach module $ModuleMenu {   puts "module = $module"
           SelectFEBEXModule $module
           
      foreach link $LinkMenu {     puts "link = $link"
          if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
          
           SelectFEBEXLink $link
          
         for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {    puts "board = $board"
         
           SelectFEBEXBoard $board   
          
#    set data reduction

           set z [catch {WriteFEBEXRegister $link $board ChDataReduction $DATA_REDUCTION} m]
           if {$z != 0} {puts "WriteFEBEXRegister for ChDataReduction => $m"}  
           
#    set channels used for self trigger signal
   
           set z [catch {WriteFEBEXRegister $link $board ChMemDisable $DISABLE_CHANNEL} m]
           if {$z != 0} {puts "WriteFEBEXRegister for ChMemReduction => $m"} 
           
#    set MODID for channel header
   
           set z [catch {WriteFEBEXRegister $link $board MODID 0xfe000100} m]
           if {$z != 0} {puts "WriteFEBEXRegister for MODID => $m"} 
           
#    set SFP id for channel header
   
           set z [catch {WriteFEBEXRegister $link $board HEADER $link} m]
           if {$z != 0} {puts "WriteFEBEXRegister for HEADER => $m"} 
           
#    reset

           set z [catch {WriteFEBEXRegister $link $board Reset 1} m]
           if {$z != 0} {puts "WriteFEBEXRegister for Reset => $m"} 

#    disable trigger acceptance 
    
           set z [catch {WriteFEBEXRegister $link $board Ctrl 0} m] 
           if {$z != 0} {puts "WriteFEBEXRegister for Ctrl => $m"} 
           
#    set test data length => 0x10000000    (disable)
   
           set z [catch {WriteFEBEXRegister $link $board DATALEN 0x10000000} m]
           if {$z != 0} {puts "WriteFEBEXRegister for DATALEN => $m"} 
           
#    set trigger delay -   this can be overridden in parameter restore

           set z [catch {WriteFEBEXRegister $link $board TrigDelay $FEB_TRIG_DELAY} m]
           if {$z != 0} {puts "WriteFEBEXRegister for TrigDelay => $m"}

#    set AD9681 output mode  -  this can be overridden in parameter restore 

           set z [catch {WriteFEBEXRegister $link $board SPI $FEB4_CODING} m]
           if {$z != 0} {puts "WriteFEBEXRegister for SPI => $m"}
           
           set z [catch {WriteFEBEXRegister $link $board SPI [expr $FEB4_SPI_READ | $FEB4_CODING]} m]
           if {$z != 0} {puts "WriteFEBEXRegister for SPI => $m"}
           
#    set trace length  - this can be overridden in parameter restore
   
           set z [catch {WriteFEBEXRegister $link $board TraceLength $FEB_TRACE_LEN} m]
           if {$z != 0} {puts "WriteFEBEXRegister for TraceLength => $m"}
           
                     
                     set z [catch {WriteFEBEX4ARegister $link $board 0 expld_mode 0} m]     
                     
                     for {set ch 0} {$ch < 16} {incr ch} {
                       set z [catch {WriteFEBEX4ARegister $link $board $ch expld_cfdfwd 1} m]
                     }
                     
                     set z [catch {WriteFEBEX4ARegister $link $board 0 expld_cfdfwd 1} m]   
       }
     }
   }
    
  }
  
   proc Halt_Electronics {} {
      global ModuleMenu LinkMenu BoardMenu
      global Options
  
   puts "Halt_Electronics" 
 
    foreach module $ModuleMenu {   puts "module = $module"
           SelectFEBEXModule $module
 
      foreach link $LinkMenu {     puts "link = $link"
          if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
          
           SelectFEBEXLink $link
           
         for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {  puts "board = $board"
         
           SelectFEBEXBoard $board           
               
#    disable trigger acceptance 
    
           set z [catch {WriteFEBEXRegister $link $board Ctrl 0} m] 
           if {$z != 0} {puts "WriteFEBEXRegister for Ctrl => $m"} 
         
        }
     }
   }
   
   }


   proc Go_Electronics {} {
      global ModuleMenu LinkMenu BoardMenu
      global Options
      global FEB_TRACE_LEN
      global REG_BUF0_DATA_LEN REG_BUF1_DATA_LEN
      global NUM_SUBMEM
  
   puts "Go_Electronics" 
   
    foreach module $ModuleMenu {         puts "module = $module"
           SelectFEBEXModule $module
           
      foreach link $LinkMenu {       puts "link = $link"
          if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
          
           SelectFEBEXLink $link
           
         for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {   puts "board = $board"
         
           SelectFEBEXBoard $board  
           
           set z [catch {WriteFEBEXRegister $link $board DATALEN 0x10000000} m]
           if {$z != 0} {puts "WriteFEBEXRegister for $REG_DATA_LEN => $m"}          
   
#    read trace length 
           
#           set z [catch {ReadFEBEXRegister $link $board TraceLength} m]
#           if {$z != 0} {puts "ReadFEBEXRegister for TraceLength => $m"; set m $FEB_TRACE_LEN}
           
#           set len [expr $m + 8]
            
#     set buffer submemories data length 
           
#           for {set k 0} {$k < $NUM_SUBMEM} {incr k} {
               
#              set z [catch {WriteFEBEXRegister $link $board  [format 0x%06x [expr $REG_BUF0_DATA_LEN + (4 * $k)]] $len} m]
#              if {$z != 0} {puts "WriteFEBEXRegister for [format 0x%06x [expr $REG_BUF0_DATA_LEN + (4 * $k)]] => $m"}

#              set z [catch {WriteFEBEXRegister $link $board  [format 0x%06x [expr $REG_BUF1_DATA_LEN + (4 * $k)]] $len} m]
#              if {$z != 0} {puts "WriteFEBEXRegister for [format 0x%06x [expr $REG_BUF1_DATA_LEN + (4 * $k)]] => $m"}
#           }         
           
#           set z [catch {WriteFEBEXRegister $link $board REG_TIME_RESET 1} m]
#           if {$z != 0} {puts "WriteFEBEXRegister for REG_TIME_RESET => $m"} 
          
#    disable trigger acceptance 
    
           set z [catch {WriteFEBEXRegister $link $board Ctrl 0} m] 
           if {$z != 0} {puts "WriteFEBEXRegister for Ctrl => $m"} 
           
#    enable trigger acceptance
 
           set z [catch {WriteFEBEXRegister $link $board Ctrl 1} m]
           if {$z != 0} {puts "WriteFEBEXRegister for Ctrl => $m"}
           
#    reset

           set z [catch {WriteFEBEXRegister $link $board Reset 1} m]
           if {$z != 0} {puts "WriteFEBEXRegister for Reset => $m"}
           
#    disable trigger acceptance   (repeat taken from HS sequence)
    
           set z [catch {WriteFEBEXRegister $link $board Ctrl 0} m]
           if {$z != 0} {puts "WriteFEBEXRegister for Ctrl => $m"} 
           
#    enable trigger acceptance
 
           set z [catch {WriteFEBEXRegister $link $board Ctrl 1} m]
           if {$z != 0} {puts "WriteFEBEXRegister forCtrl => $m"}
           
        }
     }
   }
 
   }
   
    proc ParameterCopy {Parameters} {
      global env
      global RegList1 RegList2 RegList3 RegList4 RegList5
      global ModuleMenu LinkMenu ChannelMenu
      variable Options
      
      set module [lindex $Parameters 0]    ;# the source parameters
      set link [lindex $Parameters 1]
      set board [lindex $Parameters 2]
      set allmodules [lindex $Parameters 3]
      set alllinks [lindex $Parameters 4]
      set allboards [lindex $Parameters 5]
      
      set Smodule $module
      set Slink $link
      set Sboard $board
      
      set Dmodule $::FEBEX::module      ;#   the destination parameters
      set Dlink $::FEBEX::link
      set Dboard $::FEBEX::board

       set fname [file join $env(MIDASTempDir) CopyState1.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Copy logfile not created\n$fid\n"}
       
        puts $fid "Copying Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        puts "Copying Settings using log $fname for module $module; link $link; board $board at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"] to $fname"
        
#    select Copy source

           SelectFEBEXModule $Smodule
           SelectFEBEXLink $Slink
           SelectFEBEXBoard $Sboard
                
                   foreach Reg $RegList1 {

                      set z [catch {ReadFEBEXRegister $link $board $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         set FpgaReg.$link.$board.$Reg [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg: NOT saved ($z $m)"
                      }
                   }
                  
                   foreach Reg $RegList3 {

                      set z [catch {ReadFEBEX4ARegister $link $board 0 $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         set FpgaReg.$link.$board.$Reg [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg: NOT saved ($z $m)"
                      }
                   }     
                                      
                   foreach Reg $RegList5 {

                      set z [catch {ReadFEBEX4ARegister $link $board 0 $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         set FpgaReg.$link.$board.$Reg [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg: NOT saved ($z $m)"
                      }
                   } 
                   
                foreach channel $ChannelMenu {
                   SelectFEBEXChannel $channel 
                    
                   foreach Reg $RegList2 {

                      set z [catch {ReadFEBEX4ARegister $link $board $channel $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $channel $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         set FpgaReg.$link.$board.$Reg.$channel [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $channel $Reg: NOT saved ($z $m)"
                      }
                   }
                }
                 
                set RowList [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18]
                  
                 foreach channel $RowList {
                    SelectFEBEXChannel $channel 
                    
                    foreach Reg $RegList4 {

                      set z [catch {ReadFEBEX4ARegister $link $board $channel $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg.$channel [format 0x%04x [expr $vl & 0x0003ffff]]"
                         set FpgaReg.$link.$board.$Reg.$channel [format "0x%04x" [expr $vl & 0x0003ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg.$channel: NOT saved ($z $m)"
                      }
                   }                        
                }                                      
                    
        puts $fid "Copied Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        puts "Copied Settings using log $fname at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        
        close $fid
        
       set fname [file join $env(MIDASTempDir) CopyState2.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Copy logfile not created\n$fid\n"}
       
        puts $fid "Copying Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        puts $fid "Copying Settings using log $fname for module $module; link $link; board $board at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"] to $fname"
         
#    select destination 

           SelectFEBEXModule $Dmodule
           SelectFEBEXLink $Dlink
           SelectFEBEXBoard $Dboard

         foreach link $LinkMenu {
             if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
             if {$alllinks == 0 && $link != $Dlink} {continue}
          
             SelectFEBEXLink $link    ;# select destination
          
             for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {
                if {$allboards == 0 && $board != $Dboard} {continue}
                
        puts $fid "Copying Settings for link $link; board $board" 
         
                SelectFEBEXBoard $board
                
                   foreach Reg $RegList1 {

                      set vl [set FpgaReg.$Slink.$Sboard.$Reg]
                      set z [catch {WriteFEBEXRegister $link $board $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg: NOT restored ($z $Wmsg)"
                      }
                    }
                    
                  foreach Reg $RegList3 {
                   
                      set vl [set FpgaReg.$Slink.$Sboard.$Reg]
                      set z [catch {WriteFEBEX4ARegister $link $board 0 $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg: NOT restored ($z $Wmsg)"
                      }
                    }      

                   foreach Reg $RegList5 {
                   
                      set vl [set FpgaReg.$Slink.$Sboard.$Reg]
                      set z [catch {WriteFEBEX4ARegister $link $board 0 $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg: NOT restored ($z $Wmsg)"
                      }
                    }     
                    
                 foreach channel $ChannelMenu {
                    SelectFEBEXChannel $channel
                    
                  foreach Reg $RegList2 {

                      set vl [set FpgaReg.$Slink.$Sboard.$Reg.$channel]
                      set z [catch {WriteFEBEX4ARegister $link $board $channel $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $channel $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg.$channel: NOT restored ($z $Wmsg)"
                      }
                    }
                 }                    
     
                set RowList [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18]
                  
                foreach channel $RowList {
                    SelectFEBEXChannel $channel 
                    
                    foreach Reg $RegList4 {

                      set vl [set FpgaReg.$Slink.$Sboard.$Reg.$channel]
                      set z [catch {WriteFEBEX4ARegister $link $board $channel $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg.$channel $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg.$channel: NOT restored ($z $Wmsg)"
                      }
                    }
                 }
     
              }
          }

        puts $fid "Copied Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        puts "Copied Settings for module $Dmodule; link $Dlink; board $Dboard at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"] to $fname"
        
        
        puts $fid "FEBEX settings copied from [set ::FEBEX::DBRootName]/[set ::FEBEX::DBNodeBase]/[set ::FEBEX::DBNodeName]"
        puts "Settings copied using log $fname at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        close $fid
 
   } 
   
  
  proc ParameterSave {DBkey} {
      global env
      global RegList1  RegList2  RegList3 RegList4 RegList5
      global ModuleMenu LinkMenu BoardMenu ChannelMenu
      variable DebugFlag
      variable Options

       set fname [file join $env(MIDASTempDir) SaveState.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Save logfile not created\n$fid\n"}

        puts $fid "Saving Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        puts "Saving Settings using log $fname at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set ::FEBEX::DBNodeBase $env(ComputerName)
      set ::FEBEX::DBNodeName $DBkey
      
      puts $fid "Saving FEBEX settings to [set ::FEBEX::DBRootName]/[set ::FEBEX::DBNodeBase]/[set ::FEBEX::DBNodeName]"
      puts "Saving FEBEX settings to [set ::FEBEX::DBRootName]/[set ::FEBEX::DBNodeBase]/[set ::FEBEX::DBNodeName]"


      #    registers taken from the standard GSI firmware + CFD firmware
      
           set module 0
           SelectFEBEXModule $module
       
       foreach link $LinkMenu {
          if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
          
             SelectFEBEXLink $link
          
             for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {
                 SelectFEBEXBoard $board
              
                   foreach Reg $RegList1 {

                      set z [catch {ReadFEBEXRegister $link $board $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         DBSetValue FpgaReg.$link.$board.$Reg [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg: NOT saved ($z $m)"
                      }
                    }
                    
                   foreach Reg $RegList3 {

                      set z [catch {ReadFEBEX4ARegister $link $board 0 $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         DBSetValue FpgaReg.$link.$board.$Reg [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg: NOT saved ($z $m)"
                      }
                   }     
                                      
                   foreach Reg $RegList5 {

                      set z [catch {ReadFEBEX4ARegister $link $board 0 $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         DBSetValue FpgaReg.$link.$board.$Reg [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg: NOT saved ($z $m)"
                      }
                   }       
                   
                foreach channel $ChannelMenu {
                   SelectFEBEXChannel $channel 
                    
                   foreach Reg $RegList2 {

                      set z [catch {ReadFEBEX4ARegister $link $board $channel $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $channel $Reg [format 0x%04x [expr $vl & 0x0000ffff]]"
                         DBSetValue FpgaReg.$link.$board.$Reg.$channel [format "0x%04x" [expr $vl & 0x0000ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $channel $Reg: NOT saved ($z $m)"
                      }
                   }
                 }
                 
                set RowList [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18]
                  
                 foreach channel $RowList {
                    SelectFEBEXChannel $channel 
                   
                    foreach Reg $RegList4 {

                      set z [catch {ReadFEBEX4ARegister $link $board $channel $Reg} m]
                      if {$z == 0} {
                         if {[llength $m] == 1} {set vl $m} else {set vl [lindex $m 1]}
                         puts $fid "$link $board $Reg.$channel [format 0x%04x [expr $vl & 0x0003ffff]]"
                         DBSetValue FpgaReg.$link.$board.$Reg.$channel [format "0x%04x" [expr $vl & 0x0003ffff]]
                      } else {
                         puts $fid "Error reading FEBEX register $link $board $Reg.$channel: NOT saved ($z $m)"
                      }
                   }                        
                } 
                   
              }
          }

      puts $fid "FEBEX settings saved to [set ::FEBEX::DBRootName]/[set ::FEBEX::DBNodeBase]/[set ::FEBEX::DBNodeName]"
      
      set Options(FirmWare.Settings) [set ::FEBEX::DBNodeName]

        puts "FEBEX Settings saved using log $fname at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        close $fid

   }
 
   
  proc ParameterRestore {DBkey} {
      global env
      global RegList1 RegList2 RegList3 RegList4 RegList5
      global ModuleMenu LinkMenu BoardMenu ChannelMenu
      variable DebugFlag
      variable Options

       set fname [file join $env(MIDASTempDir) RestoreState.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Restore logfile not created\n$fid\n"}
       
        puts $fid "Restoring Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        puts "Restoring Settings using log $fname at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set ::FEBEX::DBNodeBase $env(ComputerName)
      set ::FEBEX::DBNodeName $DBkey
      
      puts $fid "Restoring FEBEX settings from [set ::FEBEX::DBRootName]/[set ::FEBEX::DBNodeBase]/[set ::FEBEX::DBNodeName]"
      puts "Restoring FEBEX settings from [set ::FEBEX::DBRootName]/[set ::FEBEX::DBNodeBase]/[set ::FEBEX::DBNodeName]"

      #    registers taken from the standard GSI firmware
        
         set link 0; set board 0; set channel 0; set Reg 0
         
           set module 0
           SelectFEBEXModule $module

       foreach link $LinkMenu {
          if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
          
             SelectFEBEXLink $link
          
         for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {
         
                SelectFEBEXBoard $board
                
                   foreach Reg $RegList1 {

                      set vl [DBGetValue  FpgaReg.$link.$board.$Reg]
                      set z [catch {WriteFEBEXRegister $link $board $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg: NOT restored ($z $Wmsg)"
                      }
                    }
                    
                   foreach Reg $RegList3 {
                   
                      set vl [DBGetValue  FpgaReg.$link.$board.$Reg]
                      set z [catch {WriteFEBEX4ARegister $link $board 0 $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg: NOT restored ($z $Wmsg)"
                      }
                    }      

                   foreach Reg $RegList5 {
                   
                      set vl [DBGetValue  FpgaReg.$link.$board.$Reg]
                      set z [catch {WriteFEBEX4ARegister $link $board 0 $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg: NOT restored ($z $Wmsg)"
                      }
                    }     
                    
                 foreach channel $ChannelMenu {
                    SelectFEBEXChannel $channel
                    
                  foreach Reg $RegList2 {

                      set vl [DBGetValue  FpgaReg.$link.$board.$Reg.$channel]
                      set z [catch {WriteFEBEX4ARegister $link $board $channel $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $channel $Reg $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $channel $Reg: NOT restored ($z $Wmsg)"
                      }
                    }
                 }
                 
                 set RowList [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18]
                  
                 foreach channel $RowList {
                    SelectFEBEXChannel $channel
                  
                  foreach Reg $RegList4 {

                      set vl [DBGetValue  FpgaReg.$link.$board.$Reg.$channel]
                      set z [catch {WriteFEBEX4ARegister $link $board $channel $Reg $vl} Wmsg]
                      if {$z == 0} {
                         puts $fid "$link $board $Reg.$channel $vl"
                      } else {
                         puts $fid "Error writing FEBEX register $link $board $Reg.$channel: NOT restored ($z $Wmsg)"
                      }
                    }                  
                  }
                  
              }
          }
          
              
        puts $fid "FEBEX settings restored from [set ::FEBEX::DBRootName]/[set ::FEBEX::DBNodeBase]/[set ::FEBEX::DBNodeName]"
        puts "FEBEX Settings restored using log $fname at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        close $fid

   }   


    
proc create_FEBEX_spectra {} {
    global Options
    global ModuleMenu LinkMenu BoardMenu ChannelMenu


    set i -4
     
    foreach module $ModuleMenu {
    
      incr i
           
      foreach link [list 0 1 2 3] {
          if {$Options(FEBEX.Link[set link]NumBoards) == 0} {continue}
     
       incr i
       
         for {set board 0} {$board < $Options(FEBEX.Link[set link]NumBoards)} {incr board} {  
         incr i
       
         foreach channel $ChannelMenu {
         
           incr i
     
       if {$Options(FEBEX.Eenable) == 1} {

        set z [catch {CreateSpectrum1D E.$module$link$board.ch$channel $Options(FEBEX.Echannels)} m]   ;# Energy (16 bit integer)

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
           InsertLog "Error attempting to Create spectrum E.$module$link$board.ch$channel"
            error $m
         }
         
         set group  [expr $i+$Options(FEBEX_GroupBase)]
         set item 0

         map_spectrum "E.$module$link$board.ch$channel $group $item $Options(FEBEX.offset) $Options(FEBEX.shift)"
       }
       
       if {$Options(FEBEX.Fenable) == 1} {

        set z [catch {CreateSpectrum1D FL.$module$link$board.ch$channel $Options(FEBEX.Fchannels)} m]   ;# Energy (32 bit float low 16 bits)

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
           InsertLog "Error attempting to Create spectrum FL.$module$link$board.ch$channel"
            error $m
         }
         
         set group  [expr $i+512+$Options(FEBEX_GroupBase)]
         set item 2

         map_spectrum "FL.$module$link$board.ch$channel $group $item $Options(FEBEX.offset) $Options(FEBEX.shift)"
         
        set z [catch {CreateSpectrum1D FH.$module$link$board.ch$channel $Options(FEBEX.Fchannels)} m]   ;# Energy (32 bit float high 16 bits)

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
           InsertLog "Error attempting to Create spectrum FH.$module$link$board.ch$channel"
            error $m
         }
         
         set group  [expr $i+512+$Options(FEBEX_GroupBase)]
         set item 3

         map_spectrum "FH.$module$link$board.ch$channel $group $item $Options(FEBEX.offset) $Options(FEBEX.shift)"         
       }

       if {$Options(FEBEX.Tenable) == 1 && $channel == 0} {

        set z [catch {CreateSpectrum1D T.$module$link$board $Options(FEBEX.Tchannels)} m]    ;#   Time

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
           InsertLog "Error attempting to Create spectrum T.$module$link$board"
            error $m
         }

         set group  [expr $i+256+$Options(FEBEX_GroupBase)]
         set item 0
         
         map_spectrum "T.$module$link$board $group $item $Options(FEBEX.offset) $Options(FEBEX.Tshift)"
       }

       if {$Options(FEBEX.Wenable) == 1} {

        set z [catch {CreateSpectrum1D W.$module$link$board.ch$channel $Options(FEBEX.Wchannels)} m]     ;#  Waveform

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
           InsertLog "Error attempting to Create spectrum W.$module$link$board.ch$channel"
            error $m
         }
         
         set group  [expr $i+1024+$Options(FEBEX_GroupBase)]
         set item 0

         map_spectrum "W.$module$link$board.ch$channel $group $item $Options(FEBEX.offset) $Options(FEBEX.shift)"
       }
       
     } } } }
}
   
    proc HistogramZero {} {

       set SpecNames [SpectrumNames]
       set NumSpec 0

       ZeroSpectrum Stat
       incr NumSpec

      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a 1D histogram !!

         set SpecName [second $item]

         ZeroSpectrum $SpecName
         incr NumSpec
      }

       puts "$NumSpec spectra zeroed"
    }


 proc SpecSave1D {spec base range type title counts} {
    variable SpecPath

      set f3 [file join $SpecPath $spec.msf]
      set z1 [catch {open $f3 w} m1]
      if {$z1 != 0} then {puts "Cannot create $f3 - $m1"}
      
      set z2 [catch {file attributes $f3 -permissions rwxrwxrwx} m2]
      if {$z2 != 0} then {puts "error accessing $f3 - $m2"}

      set f $m1

      fconfigure $f -translation binary -encoding binary

  set ctime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]
  set mtime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]

      puts -nonewline $f [binary format i1 412900921]   ;#   magic number
      puts -nonewline $f [binary format i1 1]           ;#   version
      puts -nonewline $f [binary format a32 $spec]      ;#   spectrum name
      puts -nonewline $f [binary format i1 1]           ;#   dimension
      puts -nonewline $f [binary format a20 $ctime]     ;#   creation time/date
      puts -nonewline $f [binary format a20 $mtime]     ;#   modification time/date
      puts -nonewline $f [binary format i1 $base]       ;#   base0

      for {set i 2} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   baseI
      }

      puts -nonewline $f [binary format i1 $range]    ;#   range0

      for {set i 2} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   rangeI
      }

      puts -nonewline $f [binary format i1 -1]        ;#   spectrum title offset

      for {set i 2} {$i <=32} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  information pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  annotation pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  calibration pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  efficiency pointers
      }

                                                     ;#  data array 1 descriptor 
      puts -nonewline $f [binary format i1 0]        ;#  array layout
      puts -nonewline $f [binary format i1 $type]    ;#  array type  (32 bit unsigned)
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 0]        ;#  spectrum counts offset

                                                     ;#  data array 2 descriptor 
      puts -nonewline $f [binary format i1 0]        ;#  array layout
      puts -nonewline $f [binary format i1 $type]    ;#  array type 
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 -1]       ;#  spectrum counts offset

      puts -nonewline $f [binary format i1 436]      ;#  base of string space
      puts -nonewline $f [binary format i1 20]       ;#  string free space
      puts -nonewline $f [binary format i1 76]       ;#  top of string space

      puts -nonewline $f [binary format i1 512]      ;#  base of counts space
      puts -nonewline $f [binary format i1 $range]   ;#  string free space
      puts -nonewline $f [binary format i1 $range]   ;#  top of string space
 
      puts -nonewline $f [binary format a20 $title]  ;# string space - title

      for {set i 456} {$i < 512} {incr i} {
         puts -nonewline $f [binary format c1 0]     ;#  unused
      }

      puts -nonewline $f [binary format i* $counts]  ;# counts

      close $f
}

    proc HistogramSave {args} {
       global env
       variable SpecBase
       variable SpecPath

       set fname [file join $env(MIDASTempDir) HistogramSave.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Histogram Save logfile not created\n$fid\n"}

        puts "Saving  Histograms"
        puts $fid "Saving  Histograms at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set f1 $SpecBase
      set z1 [catch {file mkdir $f1} m1]
      if {$z1 != 0} then {puts $fid "Cannot create $f1 - $m1"}

      set z2 [catch {file attributes $f1 -permissions rwxrwxrwx} m2]
      if {$z2 != 0} then {puts "error accessing $f1 - $m2"}

      set f1 [file join $f1 $env(ComputerName)]
      set z1 [catch {file mkdir $f1} m1]
      if {$z1 != 0} then {puts $fid "Cannot create $f1 - $m1"}

      set z2 [catch {file attributes $f1 -permissions rwxrwxrwx} m2]
      if {$z2 != 0} then {puts "error accessing $f1 - $m2"}

      set f2 [file join $f1 [date +%Y%h%d-%H.%M.%S]]
      set z1 [catch {file mkdir $f2} m1]
      if {$z1 != 0} then {puts $fid "Cannot create $f2 - $m1"}

      set z2 [catch {file attributes $f2 -permissions rwxrwxrwx} m2]
      if {$z2 != 0} then {puts "error accessing $f2 - $m2"}
      
        puts "Saving Histograms to $f2"

       set SpecPath $f2

       set SpecNames [SpectrumNames]
       set NumSpec 0

      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a 1D histogram !!

         set SpecName [second $item]
         set spec [last [split $SpecName .]]
         set type [first [split $SpecName .]]
         
         if {$type != [first $args]} {continue}   ;#  not selected 
         
         set info [SpectrumDetails $SpecName]
         set channels [lindex $info 2]

         set title [SpectrumGetTitle $SpecName]
         set counts [SpectrumRead1D $SpecName 0 $channels]

         set z [catch {SpecSave1D $SpecName 0 $channels 5 $title $counts} m]
         if {$z!=0} then {
             puts $fid "Error attempting to save spectrum $SpecName: $m"
         } else {
             incr NumSpec
         }
      }

        puts "$NumSpec Histograms saved"
        InsertLog "$NumSpec Histograms saved` in $f2"
        puts $fid "$NumSpec Histograms saved at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        close $fid

    }

    Set_Options
    
    make-UIregisters; make-FEBEXUIregisters

    
    
