
#    Note:  This is loaded into the namespace  FEBEX_SaveRestore

# variable started 0

if {![info exists started]} {variable started 0}

global Options
global env

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0
    variable DebugFlag 0

    variable JS ""

    variable DBNameList {"xxx"}
    
    variable AcqSetOption ""
    
    global ChannelMenu
        
        variable allmodules 0
        variable alllinks 0
        variable allboards 0
    
     set ::FEBEX::DBNodeBase $env(ComputerName)
     
        variable CModule 0
        variable CLink 0
        variable CBoard 0


   proc show_variables {} {
        global MIDAS_DataAcquisitionControlServer_Exists
        global Options
        variable LogFlag
        variable ShowLogFlag
        variable AcqSetOption
       
        variable CModule
        variable CLink
        variable CBoard
        
        variable allmodules
        variable alllinks
        variable allboards   

        InsertLog "MIDAS_DataAcquisitionControlServer_Exists=$MIDAS_DataAcquisitionControlServer_Exists"

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "DBPath = $::FEBEX::DBRootName  $::FEBEX::DBNodeBase  $::FEBEX::DBNodeName"
        InsertLog "AcqSetOption = $AcqSetOption"
        
        InsertLog "Save/Restore source: $::FEBEX::module $::FEBEX::link $::FEBEX::board: all_modules=$allmodules all_links=$alllinks all_boards=$allboards"
        InsertLog "Copy source: $CModule $CLink $CBoard"

   }
     
      proc do_Save {} {
        global Options
      
        InsertLog "Saving FEBEX settings to $::FEBEX::DBRootName/$::FEBEX::DBNodeBase/$::FEBEX::DBNodeName"
        
        DAQ_DoOption "ParameterSave=$::FEBEX::DBNodeName"
        
        set Options(FirmWare.Settings) $::FEBEX::DBNodeName
        
        InsertLog "Done at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        do_DBUpdate
    }

      proc do_Restore {} {
        global Options
      
        puts "Restoring FEBEX settings from $::FEBEX::DBRootName/$::FEBEX::DBNodeBase/$Options(FirmWare.Settings)"
        
        DAQ_DoOption "ParameterRestore=$Options(FirmWare.Settings)"   
         
        InsertLog "Done at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
       
        do_DBUpdate
    }
    
     proc do_Copy {} {
        variable CModule
        variable CLink
        variable CBoard
        
        variable allmodules
        variable alllinks
        variable allboards  
      
        InsertLog "Copying FEBEX settings from module $CModule, link $CLink, board $CBoard"
        
        DAQ_DoOption "ParameterCopy=$CModule $CLink $CBoard $allmodules $alllinks $allboards"
         
        InsertLog "Done at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
        
    }    
    
      proc do_DBName {vl} {
         global Options

          set ::FEBEX::DBNodeName $vl
          DBCreateNode $::FEBEX::DBRootName/$::FEBEX::DBNodeBase/$::FEBEX::DBNodeName
          set Options(FirmWare.Settings) $vl
          SaveOptions

          InsertLog "Data Base node $::FEBEX::DBRootName/$::FEBEX::DBNodeBase contains [DBGetNodes $::FEBEX::DBRootName/$::FEBEX::DBNodeBase *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes $::FEBEX::DBRootName/$::FEBEX::DBNodeBase *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
          if {$::FEBEX::DBNodeBase == "undefined"} {set ::FEBEX::DBNodeBase [first $DBNameList]}
      }
     
     proc UpdateModule {} {}

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
        variable allmodules
        variable alllinks
        variable allboards
        variable CModule
        variable CLink
        variable CBoard

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]
           set i [second [lindex $cgidata 1]]
           set vl [third [lindex $cgidata 1]]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}
                
                HELP     {variable HelpTopic; set HelpTopic Help; do_help}                
                
                   MODULE     {SelectFEBEXModule $i; UpdateModule}
                   ALLMODULES {set allmodules [expr ($allmodules + 1) & 1]}
                   LINK     {SelectFEBEXLink $i; UpdateModule}
                   ALLLINKS {set alllinks [expr ($alllinks + 1) & 1]}
                   BOARD     {SelectFEBEXBoard $i; UpdateModule}
                   ALLBOARDS {set allboards [expr ($allboards + 1) & 1]}
                   
                   CMODULE    {set CModule $i}
                   CLINK      {set CLink $i}
                   CBOARD     {set CBoard $i}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}
                
                COPY     {do_Copy}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE      {do_Restore}
                RESTORESTATE {do_RestoreState}
                SAVE         {do_Save}
                SAVESTATE    {do_SaveState}
      
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
       
       do_DBUpdate
    }

     do_DBUpdate
     LoadOptions

     set html ""


}  ;# end of if {$started == 0}

